#!/usr/bin/python
import gtk, gobject, sys, pygame, imaplib
from pyapplets import Pyapplet
from elementtree.ElementTree import *

bonobostrings = {
'exe_loc' : 'biffimap_applet.py',
'id' : 'GNOME_biffimapApplet',
'iconpath' : 'biffimap.png',
'exe_name' : 'biffimap applet',
'exe_desc' : 'biffimap applet',
'fact_name' :'biffimap applet',
'fact_desc' :'This applet shows how many unread mails '
             'you have on your imap server'}

class Applet(Pyapplet):
    def __init__(self):
        Pyapplet.__init__(self, bonobostrings)
        #self.save_in_file('../bonoboservers/GNOME_biffimapApplet.server')
        self.parsecfg()

        server = self.cfg['server']
        username = self.cfg['username']
        password = self.cfg['password']
        #interval in milliseconds
        self.interval = int(float(self.cfg['interval']) * 60000)
        soundfile = self.cfg['soundfile']

        pygame.mixer.init(44100)
        self.sound = pygame.mixer.Sound(soundfile)

        self.connect = imaplib.IMAP4_SSL(server)
        self.connect.login(username, password)
        result, message = self.connect.select(readonly=1)
        if result != 'OK':
                raise Exception, message
        self.highest_id = 0 #Just initial value
        self.unseen_status()

        self.label = gtk.Label()
        self.__update()
        self.label.show()
        self.widget = self.label

    def parsecfg(self):
        xml_cfg = self.get_my_xml_cfg()
        self.cfg = ElementTree(file = xml_cfg).getroot().attrib

    def unseen_status(self):
        response, items = self.connect.search(None, 'UNSEEN')
        splitted = items[0].split()
        howmanyunseen = len(splitted)
        isnew = False
        isfresh = False
        try:
            thismax = max([int(x) for x in splitted])
            if thismax > self.highest_id:
                self.highest_id = thismax
                isnew = True
                isfresh = True
                self.sound.play()
            elif thismax == self.highest_id:
                isnew = True
        except ValueError:
            pass
        return isnew, isfresh, howmanyunseen

    def __update(self):
        gobject.timeout_add(self.interval, self.__update)
        isnew, isfresh, howmanyunseen = self.unseen_status()
        text = '%d ' %howmanyunseen
        if isfresh:
            color = 'red'
        elif isnew:
            color = 'yellow'
        else:
            color = 'white'
        text = '<span background="%s">%s</span>' %(color, text)
        self.label.set_markup(text)


if __name__ == '__main__':
    test = (len(sys.argv) == 1)
    appl = Applet()
    appl.run(test)
