#!/usr/bin/python
import gtk, gobject, time, locale, sys
from pyapplets import Pyapplet
from elementtree.ElementTree import *

bonobostrings = {
'exe_loc' : 'strftime_applet.py',
'id' : 'GNOME_strftimeApplet',
'iconpath' : 'strftime.png',
'exe_name' : 'strftime applet',
'exe_desc' : 'strftime applet',
'fact_name' : 'strftime applet',
'fact_desc' : 'This applet shows date and time using strftime format string'}

class Applet(Pyapplet):
    def __init__(self):
        Pyapplet.__init__(self, bonobostrings)
        self.label = gtk.Label()
        self.parsecfg()
        self.label.show()
        self.__update()
        self.widget = self.label

    def parsecfg(self):
        root = ElementTree(file = self.get_my_xml_cfg()).getroot()
        self.formatstring = root.attrib['formatstring']
        self.lc_time = root.attrib['LC_TIME']
        try:
            justify = {'left':gtk.JUSTIFY_LEFT,
                       'right':gtk.JUSTIFY_RIGHT,
                       'center':gtk.JUSTIFY_CENTER}[root.attrib['justify']]
            self.label.set_justify(justify)
        except:
            pass

    def __update(self):
        sec = time.time()
        now = time.localtime(sec)
        if self.lc_time:
            locale.setlocale(locale.LC_TIME, self.lc_time)
        self.label.set_text(time.strftime(self.formatstring, now))
        timeout = 2 + int(1000 * ( 1 - sec%1))
        gobject.timeout_add(timeout, self.__update)

if __name__ == '__main__':
    test = (len(sys.argv) == 1)
    appl = Applet()
    #appl.save_in_file('GNOME_strftimeApplet.server')
    appl.run(test)
