#!/usr/bin/python
import gtk, gobject, sys, pygame, time
from pyapplets import Pyapplet
from elementtree.ElementTree import *

bonobostrings = {
'exe_loc' : 'timer_applet.py',
'id' : 'GNOME_timerApplet',
'iconpath' : 'timer.png',
'exe_name' : 'timer applet',
'exe_desc' : 'timer applet',
'fact_name' :'timer applet',
'fact_desc' :'This is simple countdown applet.'}

class Applet(Pyapplet):
    def __init__(self):
        Pyapplet.__init__(self, bonobostrings)
        #self.save_in_file('../bonoboservers/GNOME_timerApplet.server')
        self.parsecfg()
        soundfile = self.cfg['soundfile']
        pygame.mixer.init(44100)
        self.sound = pygame.mixer.Sound(soundfile)

        adj = gtk.Adjustment(0.0, 0.0, 9999.0, 1.0, 10.0, 0.0)
        self.minrel = gtk.SpinButton(adj, 0, 0)
        self.minrel.set_numeric(True)
        self.minrel.set_snap_to_ticks(True)
        self.minrel.set_update_policy(gtk.UPDATE_IF_VALID)
        #self.minrel.set_wrap(True)
        self.spinvalue = self.minrel.get_value_as_int()
        self.minrel.connect('value-changed', self.minrel_changed)
        self.stepdown()
        self.minrel.show()
        self.widget = self.minrel

    def start_timer(self):
        if self.timeout:
            gobject.source_remove(self.timeout)
        ms = 2 + int(1000 * (60 - time.time() % 60)) #milliseconds till whole minute
        #ms = 1000 #just testing
        self.timeout = gobject.timeout_add(ms, self.stepdown, None)

    def stop_timer(self):
        if self.timeout:
            gobject.source_remove(self.timeout)
            self.timeout = None

    def minrel_changed(self, widget):
        currvalue = self.minrel.get_value_as_int()
        if currvalue < self.spinvalue: #zmensil hodnotu
            pass
        elif currvalue > self.spinvalue: #zvetsil hodnotu => nastartuj
            self.start_timer()
        else: #tohle musel udelat casovac
            if currvalue != 0:
                self.start_timer()
            else:
                self.sound.play()
                self.stop_timer()
        self.spinvalue = currvalue

    def stepdown(self, widget = None):
        self.timeout = None
        currvalue = self.minrel.get_value_as_int()
        self.spinvalue = currvalue - 1
        self.minrel.set_value(self.spinvalue)

    def parsecfg(self):
        xml_cfg = self.get_my_xml_cfg()
        self.cfg = ElementTree(file = xml_cfg).getroot().attrib


if __name__ == '__main__':
    test = (len(sys.argv) == 1)
    appl = Applet()
    appl.run(test)
