#!/usr/bin/python
import gnomeapplet, gtk, pwd, os, posix, shutil, sys

class Pyapplet:
    def __init__(self, bonobostrings):
        self.bonobostrings = bonobostrings

    def makexml(self):
        self.xml = '''\
<oaf_info>
    <oaf_server iid="OAFIID:%(id)s_Factory"
        type="exe" location="/usr/bin/%(exe_loc)s">

        <oaf_attribute name="repo_ids" type="stringv">
             <item value="IDL:Bonobo/GenericFactory:1.0"/>
             <item value="IDL:Bonobo/Unknown:1.0"/>
        </oaf_attribute>
        <oaf_attribute name="name" type="string"
            value="%(exe_name)s"/>
        <oaf_attribute name="description" type="string"
            value="%(exe_desc)s"/>
    </oaf_server>

    <oaf_server iid="OAFIID:%(id)s"
        type="factory" location="OAFIID:%(id)s_Factory">

        <oaf_attribute name="repo_ids" type="stringv">
                        <item value="IDL:GNOME/Vertigo/PanelAppletShell:1.0"/>
                        <item value="IDL:Bonobo/Control:1.0"/>
                        <item value="IDL:Bonobo/Unknown:1.0"/>
        </oaf_attribute>

        <oaf_attribute name="name" type="string" value="%(fact_name)s"/>
        <oaf_attribute name="description" type="string"
            value="%(fact_desc)s"/>
        <oaf_attribute name="panel:category" type="string" value="Utility"/>
        <oaf_attribute name="panel:icon" type="string"
            value="/usr/share/pixmaps/%(iconpath)s"/>
    </oaf_server>
</oaf_info>
''' %self.bonobostrings

    def save_in_file(self, filename):
        self.makexml()
        file(filename, 'w').write(self.xml)

    def __factory(self, applet, iid):
        applet.add(self.widget)
        applet.show()
        return True

    def run(self, test = False):
        if test:
            main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
            title = '%(exe_name)s (test)' %self.bonobostrings
            main_window.set_title(title)
            main_window.connect("destroy", gtk.main_quit)
            app = gnomeapplet.Applet()
            self.__factory(app, None)
            app.reparent(main_window)
            main_window.show()
            gtk.main()

        else:
            gnomeapplet.bonobo_factory(
                "OAFIID:%(id)s_Factory" %self.bonobostrings,
                gnomeapplet.Applet.__gtype__,
                "hello", "0", self.__factory)

    def get_cfgdir(self):
        homedir = pwd.getpwuid(posix.getuid()).pw_dir
        cfgdir = os.path.join(homedir, '.gnome-pyapplets-misc')
        if not os.path.isdir(cfgdir):
            shutil.copytree('/usr/share/gnome-pyapplets-misc', cfgdir)
        return cfgdir

    def get_my_xml_cfg(self):
        cfgdir = self.get_cfgdir()
        name = os.path.basename(self.bonobostrings['exe_loc'])
        cfgname = os.path.splitext(name)[0] + '.xml'
        cfgpath = os.path.join(cfgdir, cfgname)
        return cfgpath
